/*!
 * UI development toolkit for HTML5 (OpenUI5)
 * (c) Copyright 2009-2016 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
sap.ui.define(['jquery.sap.global','./Element','./library'],function(q,E,l){"use strict";var M=l.MessageType;var a=E.extend("sap.ui.core.Message",{metadata:{library:"sap.ui.core",properties:{text:{type:"string",group:"Misc",defaultValue:null},timestamp:{type:"string",group:"Misc",defaultValue:null},icon:{type:"sap.ui.core.URI",group:"Misc",defaultValue:null},level:{type:"sap.ui.core.MessageType",group:"Misc",defaultValue:M.None},readOnly:{type:"boolean",group:"Misc",defaultValue:false}}}});a.prototype.getDefaultIcon=function(s){var m=q.sap.getModulePath("sap.ui.core.themes."+sap.ui.getCore().getConfiguration().getTheme());var i=m+"/img/message/";if(s&&s=="32x32"){i+="32x32/";}else{i+="16x16/";}var u="";switch(this.getProperty("level")){case M.Error:u=i+"Message_Icon_Error.png";break;case M.Information:u=i+"Message_Icon_Information.png";break;case M.Warning:u=i+"Message_Icon_Warning.png";break;case M.Success:u=i+"Message_Icon_Success.png";break;case M.None:default:u=this.getProperty("icon");break;}return u;};a.prototype.compareByType=function(o){return a.compareByType(this,o);};a.compareByType=function(m,o){if(!m&&!o){return 0;}if(m&&!o){return 1;}if(!m&&o){return-1;}var L=m.getLevel();var s=o.getLevel();if(L===s){return 0;}switch(L){case M.Error:return 1;case M.Warning:return s===M.Error?-1:1;case M.Success:return s===M.Error||s===M.Warning?-1:1;case M.Information:return s===M.None?1:-1;case M.None:return-1;default:q.sap.log.error("Comparison error",this);return 0;}};return a;});
